// TexturePropPage.cpp : implementation file
//

#include "stdafx.h"
#include "Frontend.h"
#include "TexturePropPage.h"
#include ".\textureproppage.h"
#include "loadbmp.h"


// CTexturePropPage dialog

IMPLEMENT_DYNAMIC(CTexturePropPage, CPropertyPage)

CTexturePropPage::CTexturePropPage()
	: CPropertyPage(CTexturePropPage::IDD)
	, TEXTURE_MAPPING(FALSE)
	, TEXTURE_NAME(_T(""))
	, TEXTURE_EDGE_LEN(0)
{
}

CTexturePropPage::~CTexturePropPage()
{
}


void CTexturePropPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_TEXTUREMAPCHECK, TEXTURE_MAPPING);
	DDX_Control(pDX, IDC_STATICPIC, TexturePreview);
	DDX_Control(pDX, IDC_TEXTSCALEEDIT, ScaleEdit);
	DDX_Text(pDX, IDC_TEXTFILEEDIT, TEXTURE_NAME);
	DDX_Text(pDX, IDC_TEXTSCALEEDIT, TEXTURE_EDGE_LEN);
	DDV_MinMaxFloat(pDX, TEXTURE_EDGE_LEN, 0, 2048);
	DDX_Control(pDX, IDC_SIZESLIDER, ScaleSlider);
	DDX_Control(pDX, IDC_TEXTFILEEDIT, TextFileEdit);
}


BEGIN_MESSAGE_MAP(CTexturePropPage, CPropertyPage)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SIZESLIDER, OnNMCustomdrawSizeslider)
	ON_BN_CLICKED(IDC_TEXTFILEBUTTON, OnBnClickedTextfilebutton)
	ON_EN_CHANGE(IDC_TEXTSCALEEDIT, OnEnUpdateTextscaleedit)
	ON_EN_UPDATE(IDC_TEXTFILEEDIT, OnEnUpdateTextfileedit)
END_MESSAGE_MAP()


BOOL CTexturePropPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	ScaleSlider.SetRangeMin(0);
	ScaleSlider.SetRangeMax(2048);

	ScaleSlider.SetPos(TEXTURE_EDGE_LEN);

	CTexturePropPage::OnEnUpdateTextfileedit();

	return TRUE;
}

// CTexturePropPage message handlers

void CTexturePropPage::OnNMCustomdrawSizeslider(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);

	SetDlgItemInt(IDC_TEXTSCALEEDIT, ScaleSlider.GetPos());

	*pResult = 0;
}

void CTexturePropPage::OnBnClickedTextfilebutton()
{
	CFileDialog diag(TRUE, NULL, 0, OFN_HIDEREADONLY | 
		OFN_FILEMUSTEXIST | 
		OFN_NOCHANGEDIR,
		"Bitmaps (*.bmp)|*.bmp||", this);

	CString fname;

	if (diag.DoModal() == IDOK)
	{
		char dir[256];

		GetCurrentDirectory(256, dir);

		if ((CString(dir) + "\\" + diag.GetFileName()).CompareNoCase(diag.GetPathName()) != 0)
		{
			fname = diag.GetPathName();
			if (GetShortPathName(fname, dir, 256))
			{
				fname = dir;
			}
		}
		else
		{
			fname = diag.GetFileName();
		}
	}

	TextFileEdit.SetWindowText(fname);

}

void CTexturePropPage::OnEnUpdateTextscaleedit()
{
	ScaleSlider.SetPos(GetDlgItemInt(IDC_TEXTSCALEEDIT));
}

void CTexturePropPage::OnEnUpdateTextfileedit()
{
	CString name;
	CBitmap *bmp;
	int res;

	TextFileEdit.GetWindowText(name);
	res = LoadBitmapFromFile(name.GetBuffer(), &bmp);
	if (res == BMP_TEXT)
	{
		TexturePreview.SetBitmap(*bmp);
	}
	else
	{
		if (res != BMP_LOAD_ERROR)
		{
			AfxMessageBox("texture edge_len has to be 2**n");
		}
		TexturePreview.SetBitmap(::LoadBitmap(theApp.m_hInstance, MAKEINTRESOURCE(IDB_FILENOTFOUND)));
	}
}
