#pragma once

#include "stdafx.h"

#define PARAM_INT    0
#define PARAM_FLOAT  1
#define PARAM_STRING 2

#define PARAM_ERROR 0xffff

enum PrefNames
{

#define PARAMETER(name, type, value, page) PARAM_ ## name,
#include "..\Source\params.h"
#undef PARAMETER

};

typedef union sym_data_tag {

	int int_val;
	float float_val;
	char *string_val;

	sym_data_tag() {}
	sym_data_tag(int i) { int_val = i; }
	sym_data_tag(float f) { float_val = f; }
	sym_data_tag(char *c) { string_val = c; }

} sym_data;


typedef struct symtable_tag
{
	unsigned char type;
	sym_data data;
} *symtable;

class Preferences {

    private:
      symtable sym_table;
	  char **pref_names;
	  int pref_count;

      int Preferences::LookUp(char *);

	public:
		Preferences();
		~Preferences();

        int create_sym(PrefNames pref, int type, sym_data value);
		int putsym(char *sym_name, int type, sym_data value);
        int putsym(PrefNames pref, int type, sym_data value);
		sym_data getsym(PrefNames pref, int type);
		sym_data getsym(char *sym_name, int type);

		int getsymtype(char *sym_name);

		bool LoadConfig(char *file);
};

#define GET_INT_PARAM(pref) getsym(pref, PARAM_INT).int_val
#define GET_FLOAT_PARAM(pref) getsym(pref, PARAM_FLOAT).float_val
#define GET_STRING_PARAM(pref) getsym(pref, PARAM_STRING).string_val


