/*
  main application class
*/

#ifndef __GEZAPPLICATION_H__
#define __GEZAPPLICATION_H__

#define WIN32_LEAN_AND_MEAN

#define DIRECTINPUT_VERSION 0x0800
#include <dinput.h>

#include "Error.h"
#include "Camera.h"
#include "Console.h"
#include "preferences.h"

#define CONFIG_FILE "terrain.ini"

extern Console *g_console;

class Application
{
  friend int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil);

  private:

		bool benchmark;
		int  frames_rendered;


		HINSTANCE hInstance;
		PIXELFORMATDESCRIPTOR pfd;
		HGLRC hglrc;

		Camera camera;
		Console console;

		LPDIRECTINPUT8       lpDInput;
		LPDIRECTINPUTDEVICE8 lpDIMouse;
		HANDLE               hMouseEvent;

		bool bActive;		// true when window is not minimized
		bool initialized;	// true after Initialize()

	public:
		Preferences prefs;
		BYTE bKey[256];		// keyboard state

		HDC hdc;			// handle to device context
		DWORD threadID;		// thread ID
		HWND hwnd;			// application main-window

		Application();
		~Application();

		GEZERROR Initialize(HINSTANCE);

		GEZERROR Render();

		static LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);

		void MousePos(int x, int y);
};

#endif /* ifndef __GEZAPPLICATION_H__ */

