/*
  the console provides means to communicate with the user
*/

#ifndef __GEZCONSOLE_H__
#define __GEZCONSOLE_H__

#ifndef	_ANSIDECL_H
#define _ANSIDECL_H
#endif	

#include <windows.h>

#include "stdarg.h"
#include "GL\gl.h"


class Console
{
	private:

		char *log_name;
		bool gui_init;
		float y_pos, y_offset;

		char con_buf[8][128];
		long long con_times[8];
		long long delete_interval, time;
		GLuint base;

		int pos;

		void ToVaList(const char *format, va_list list);

	public:
		Console();
		~Console();

		bool Initialize(char *log_file);
		void Output(const char *, ...);
		void Separator(bool bold = false);

		bool init_gui();
		void ScrOutput(const char *string, ...);
		void ShowConsole(bool reset_y_pos = true);
		void ScrPrint(const char *string); // CAUTION: destroys ModelView Matrix
		void GuiResetYPos() { y_pos = 0.55f; };
};

#endif // ifndef __GEZCONSOLE_H__

