/*
  error constants & functions
*/

#ifndef __GEZERROR_H__
#define __GEZERROR_H__

#include "Assert.h"
#include "Console.h"
#include "stdlib.h"

#define GEZERROR int

#define GEZ_OK                 0x0000
#define GEZ_OUTOFMEM           0x0001
#define GEZ_ALREADYINITIALIZED 0x0002
#define GEZ_UNKNOWN            0xffff

#ifdef _DEBUG
	#define WARN(x) { extern Console *g_console; ASSERT(0, "WARNING: " # x); g_console ? g_console->Output(x) : 0; }
	#define FAIL(x) { extern Console *g_console; ASSERT(0, "ERROR: " # x); g_console ? g_console->Output(x) : 0; exit(1); }
#else
	#define WARN(x) { extern Console *g_console; MessageBox(NULL, x, "Warning", MB_SYSTEMMODAL); g_console ? g_console->Output(x) : 0;}
	#define FAIL(x) { extern Console *g_console; MessageBox(NULL, x, "Error", MB_SYSTEMMODAL); g_console ? g_console->Output(x) : 0; exit(1);}
#endif /* ifdef _DEBUG */

#endif /* ifndef __GEZERROR_H__ */

