#include "Map.h"
#include "stdio.h"
#include "Application.h"
#include "Assert.h"
#include "loadbmp.h"
#include "math.h"

Map::Map()
{
  data = NULL;
}

Map::~Map()
{
  if (data != NULL)
  {
    delete data;
    data = NULL;
  }
}

GEZERROR Map::LoadMap(char *name)
{
	BITMAP bm;
	int i;

	g_console->Output("Loading map... ");

	if (LoadMapFromBitmapFile(name, &bm) == NULL)
	{
		g_console->Output("failed!\n");
		return GEZ_UNKNOWN;
	}

	Map::data = (unsigned char *)bm.bmBits;
	width = bm.bmWidth;
	height = bm.bmHeight;

	if (width != height)
	{
		FAIL("bitmap hast to be square and of edge len n**2+1!");
	}

	for (i = 2; i < 20; i++)
	{
		if (pow(2, i) + 1 == width) break;
	}
	if (i == 20)
	{
		FAIL("bitmap hast to be square and of edge len 2**n+1!");
	}

	g_console->Output("done\n");

	return GEZ_OK;
}

