/*
  This file contains the engine settings definitions & default values
*/

PARAMETER(FULLSCREEN,    INT,     0, General)
PARAMETER(     WIDTH,    INT,   800, General)
PARAMETER(    HEIGHT,    INT,   600, General)

PARAMETER(TRANS_SPEED,  FLOAT, 5.0f, Controls)
PARAMETER(FREE_MOVE,     INT,    0, Controls)

PARAMETER(BENCHMARK, INT, 0, General)
PARAMETER(SHOW_CULL, INT, 0, General)

PARAMETER(USE_VERTEX_ARRAY, INT, 0, OpenGL)
PARAMETER(USE_COMPILED_VERTEX_ARRAY, INT, 0, OpenGL)
PARAMETER(USE_MULTIDRAW_EXT, INT, 0, OpenGL)

PARAMETER(USE_ARB_EXT,   INT,    0, OpenGL)

PARAMETER(GLOBAL_DETAIL, FLOAT,  9.0f, General)
PARAMETER(LOCAL_DETAIL,  FLOAT,  3.0f, General)
PARAMETER(MAX_DETAIL,    INT,   32, General)
PARAMETER(MIN_DETAIL,    INT,    3, General)

PARAMETER(FRUSTUM_CULLING, INT,  1, General)

PARAMETER(FIELD_OF_VIEW, FLOAT, 60.0f, OpenGL)       /* in y direction */
PARAMETER(FIELD_OF_VIEW_ASPECT, FLOAT, 1.0f, OpenGL) /* to x-direction */
PARAMETER(CLIP_PLANE_NEAR, FLOAT,  0.1f, OpenGL)
PARAMETER(CLIP_PLANE_FAR, FLOAT, 150.0f, OpenGL)

PARAMETER(TEXTURE_MAPPING, INT, 1, Texture)       // turn texture mapping on & off
PARAMETER(TEXTURE_EDGE_LEN, FLOAT, 1.0f, Texture) // edge_len of the texture in map coordinates

PARAMETER(MAP_NAME, STRING, "257x257.bmp", General)
PARAMETER(TEXTURE_NAME, STRING, "G.bmp", Texture)

/* controls */
PARAMETER(STRAFE_LEFT,      STRING, "S", Controls) 
PARAMETER(STRAFE_RIGHT,     STRING, "F", Controls)
PARAMETER(MOVE_FORWARD,     STRING, "E", Controls)
PARAMETER(MOVE_BACKWARD,    STRING, "D", Controls)
PARAMETER(MOVE_UP,          STRING, "A", Controls)
PARAMETER(MOVE_DOWN,        STRING, "Y", Controls)

PARAMETER(SHADE_SWITCH,     STRING, "J", Controls)
PARAMETER(POLY_SWITCH,      STRING, "U", Controls)
PARAMETER(TEXTURE_SWITCH,   STRING, "T", Controls)
PARAMETER(CULL_SWITCH,      STRING, "C", Controls)

PARAMETER(DETAIL_UP,        STRING, "O", Controls)
PARAMETER(DETAIL_DOWN,      STRING, "L", Controls)
PARAMETER(LOCALDETAIL_UP,   STRING, "I", Controls)
PARAMETER(LOCALDETAIL_DOWN, STRING, "K", Controls)

