#include "Vector.h"

#include <math.h>

Vector3f* vectorCrossProd(Vector3f *v1, Vector3f *v2, Vector3f *vResult)
{
  //calculate cross product v1 x v2
  vResult->x = ((v1->y * v2->z) - (v1->z * v2->y));
  vResult->y = ((v1->z * v2->x) - (v1->x * v2->z));
  vResult->z = ((v1->x * v2->y) - (v1->y * v2->x));

  //return cross product	
  return vResult;
}

float vectorMagnitude(Vector3f *v)
{
  // magnitude = |v| = sqrt(v.x^2 + v.y^2 + v.z^2)
  return (float)sqrt(
    v->x * v->x + 
    v->y * v->y + 
    v->z * v->z
  );
}

void vectorNormalize(Vector3f *vect)
{
  //get magnitude of vector
  float m = vectorMagnitude(vect);
  
  //now that we know the magnitude, we can divide the vector by that magnitude.
  //the resulting vector will have a total length of 1.
  
  vect->x /= m;
  vect->y /= m;
  vect->z /= m;
}

