#ifndef __GEZVECTOR_H__
#define __GEZVECTOR_H__

typedef struct Vector3f_Tag
{
  float x,y,z;

	
  Vector3f_Tag() { x = y = z = 0.0; }
  Vector3f_Tag(float ox, float oy, float oz)  { x = ox, y = oy, z = oz; }

  Vector3f_Tag &operator *(float scalar)
  {
    this->x *= scalar;
    this->y *= scalar;
    this->z *= scalar;
  
    return *this;
  }
  
  Vector3f_Tag &operator +(Vector3f_Tag &w)
  {
    this->x += w.x;
    this->y += w.y;
    this->z += w.z;
  
    return *this;
  }

} Vector3f;

void vectorNormalize(Vector3f *vect);
float vectorMagnitude(Vector3f *v);
Vector3f* vectorCrossProd(Vector3f *v1, Vector3f *v2, Vector3f *vResult);

#endif // #ifndef __GEZVECTOR_H__

